The Canva Apps SDK, Connect APIs, and MCP are now unified in the Canva Developers SDK. Learn more(opens in a new tab or window).
Canva Developers SDK
The Canva Apps SDK, Connect APIs, and MCP are now unified in the Canva Developers SDK. Learn more(opens in a new tab or window).

Create image-to-design import job

This API is currently provided as a preview. Be aware of the following:

  • There might be unannounced breaking changes.
  • Any breaking changes to preview APIs won't produce a new API version.
  • Public integrations that use preview APIs will not pass the review process, and can't be made available to all Canva users.

Starts a new asynchronous job to convert an image into an editable design in Canva, using Magic Layers(opens in a new tab or window). Elements in the image become separate editable layers in the resulting design.

Provide the image as an asset that is already in the user's Canva account.

The image must be a standard photo or graphic file, such as a PNG or JPEG. Vector-based formats such as SVG, EPS, or AI files, are not supported. Video assets are not supported.

This conversion is designed for flat, non-photographic images such as posters, flyers, banners, and social graphics.

Starting a job consumes the user's AI credit allowance(opens in a new tab or window). If the user has reached their AI allowance limit, the request returns a 429 error with the credit_quota_exceeded code. Polling for the result of a job using the Get image-to-design import job API doesn't consume any of the allowance.

Use this API when the user wants to edit the contents of the image, such as changing its text, colors, or individual elements. If you only need to place the image into a design as a single flat image, use the Create design API with an asset_id instead. The Create design API doesn't consume AI credits.

For more information on the workflow for using asynchronous jobs, see API requests and responses. You can check the status and get the results of image-to-design import jobs created with this API using the Get image-to-design import job API.

HTTP method and URL path

POST https://api.canva.com/rest/v1/image-to-design-imports

This operation is rate limited to 20 requests per minute for each user of your app.

Authentication and authorization

This endpoint requires a valid access token that acts on behalf of a user.

Scopes

The access token must have all the following scopes (permissions):

  • design:content:write

Capabilities

The user must have at least one of the following capabilities:

  • image_to_design_imports

Header parameters

Authorizationstring
Required

Provides credentials to authenticate the request, in the form of a Bearer token.

For example: Authorization: Bearer {token}

Content-Typestring
Required

Indicates the media type of the information sent in the request. This must be set to application/json.

For example: Content-Type: application/json

Body parameters

imageImageSource
Required

The image to convert into a design.

asset_idstring
Required

The ID of an image asset in the user's Canva account.

The asset must be one of the following image types: png, jpeg, gif, webp, heic, heif, avif, tiff, jp2, jpx, jpm, or jxr. Video assets are not supported.

titlestring
Optional

A title for the created design. If not provided, Canva generates a title.

Minimum length: 1

Maximum length: 255

Example request

Examples for using the /v1/image-to-design-imports endpoint:

curl --request POST 'https://api.canva.com/rest/v1/image-to-design-imports' \
--header 'Authorization: Bearer {token}' \
--header 'Content-Type: application/json' \
--data '{
"image": {
"asset_id": "Msd59349ff"
},
"title": "My Image Design"
}'
SH
const fetch = require("node-fetch");
fetch("https://api.canva.com/rest/v1/image-to-design-imports", {
method: "POST",
headers: {
"Authorization": "Bearer {token}",
"Content-Type": "application/json",
},
body: JSON.stringify({
"image": {
"asset_id": "Msd59349ff"
},
"title": "My Image Design"
}),
})
.then(async (response) => {
const data = await response.json();
console.log(data);
})
.catch(err => console.error(err));
JS
import java.io.IOException;
import java.net.URI;
import java.net.http.*;
public class ApiExample {
public static void main(String[] args) throws IOException, InterruptedException {
HttpRequest request = HttpRequest.newBuilder()
.uri(URI.create("https://api.canva.com/rest/v1/image-to-design-imports"))
.header("Authorization", "Bearer {token}")
.header("Content-Type", "application/json")
.method("POST", HttpRequest.BodyPublishers.ofString("{\"image\": {\"asset_id\": \"Msd59349ff\"}, \"title\": \"My Image Design\"}"))
.build();
HttpResponse<String> response = HttpClient.newHttpClient().send(
request,
HttpResponse.BodyHandlers.ofString()
);
System.out.println(response.body());
}
}
JAVA
import requests
headers = {
"Authorization": "Bearer {token}",
"Content-Type": "application/json"
}
data = {
"image": {
"asset_id": "Msd59349ff"
},
"title": "My Image Design"
}
response = requests.post("https://api.canva.com/rest/v1/image-to-design-imports",
headers=headers,
json=data
)
print(response.json())
PY
using System.Net.Http;
var client = new HttpClient();
var request = new HttpRequestMessage
{
Method = HttpMethod.Post,
RequestUri = new Uri("https://api.canva.com/rest/v1/image-to-design-imports"),
Headers =
{
{ "Authorization", "Bearer {token}" },
},
Content = new StringContent(
"{\"image\": {\"asset_id\": \"Msd59349ff\"}, \"title\": \"My Image Design\"}",
Encoding.UTF8,
"application/json"
),
};
using (var response = await client.SendAsync(request))
{
response.EnsureSuccessStatusCode();
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
};
CSHARP
package main
import (
"fmt"
"io"
"net/http"
"strings"
)
func main() {
payload := strings.NewReader(`{
"image": {
"asset_id": "Msd59349ff"
},
"title": "My Image Design"
}`)
url := "https://api.canva.com/rest/v1/image-to-design-imports"
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer {token}")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}
GO
$curl = curl_init();
curl_setopt_array($curl, array(
CURLOPT_URL => "https://api.canva.com/rest/v1/image-to-design-imports",
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => array(
'Authorization: Bearer {token}',
'Content-Type: application/json',
),
CURLOPT_POSTFIELDS => json_encode([
"image" => [
"asset_id" => "Msd59349ff"
],
"title" => "My Image Design"
])
));
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if (empty($err)) {
echo $response;
} else {
echo "Error: " . $err;
}
PHP
require 'net/http'
require 'uri'
url = URI('https://api.canva.com/rest/v1/image-to-design-imports')
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request['Authorization'] = 'Bearer {token}'
request['Content-Type'] = 'application/json'
request.body = <<REQUEST_BODY
{
"image": {
"asset_id": "Msd59349ff"
},
"title": "My Image Design"
}
REQUEST_BODY
response = http.request(request)
puts response.read_body
RUBY

Success response

If successful, the endpoint returns a 200 response with a JSON body with the following parameters:

jobImageToDesignImportJob

The status and result of an image-to-design import job.

idstring

The ID of the image-to-design import job.

statusstring

The status of the design import job.

Available values:

  • failed
  • in_progress
  • success
resultImageToDesignImportJobResult
Optional
designDesignSummary

Basic details about the design, such as the design's ID, title, and URL.

idstring

The design ID.

urlsDesignLinks

A temporary set of URLs for viewing or editing the design.

edit_urlstring

A temporary editing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support return navigation workflows.

This is not a permanent URL, it is only valid for 30 days.

view_urlstring

A temporary viewing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support return navigation workflows.

This is not a permanent URL, it is only valid for 30 days.

created_atinteger

When the design was created in Canva, as a Unix timestamp (in seconds since the Unix Epoch).

updated_atinteger

When the design was last updated in Canva, as a Unix timestamp (in seconds since the Unix Epoch).

titlestring
Optional

The design title.

urlstring
Optional

URL of the design.

thumbnailThumbnail
Optional

A thumbnail image representing the object.

widthinteger

The width of the thumbnail image in pixels.

heightinteger

The height of the thumbnail image in pixels.

urlstring

A URL for retrieving the thumbnail image. This URL expires after 15 minutes. This URL includes a query string that's required for retrieving the thumbnail.

page_countinteger
Optional

The total number of pages in the design. Some design types don't have pages (for example, Canva docs).

errorImageToDesignImportError
Optional

If the import job fails, this object provides details about the error.

codestring

A short string about why the import failed. This field can be used to handle errors programmatically.

Available values:

  • bad_input
  • moderation_error
  • quota_exceeded
  • design_creation_throttled
  • internal_error
messagestring

A human-readable description of what went wrong.

Example responses

In progress image-to-design import job

{
"job": {
"id": "f81b26fd-a33d-4c2d-9e8c-4a7aca798b17",
"status": "in_progress"
}
}
JSON

Successfully completed image-to-design import job

{
"job": {
"id": "f81b26fd-a33d-4c2d-9e8c-4a7aca798b17",
"status": "success",
"result": {
"design": {
"id": "DAFVztcvd9z",
"title": "My Image Design",
"thumbnail": {
"width": 800,
"height": 600,
"url": "https://document-export.canva.com/..."
},
"urls": {
"edit_url": "https://www.canva.com/design/DAFVztcvd9z/edit",
"view_url": "https://www.canva.com/design/DAFVztcvd9z/view"
},
"created_at": 1726198998,
"updated_at": 1726199000
}
}
}
}
JSON

Failed image-to-design import job

{
"job": {
"id": "f81b26fd-a33d-4c2d-9e8c-4a7aca798b17",
"status": "failed",
"error": {
"code": "internal_error",
"message": "An unexpected error occurred while converting the image. Please try again."
}
}
}
JSON

Error responses

400 Bad Request

codestring

A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.

messagestring

A human-readable description of what went wrong.

Example error response

The provided asset is not a supported image type
{
"code": "unsupported_asset",
"message": "'asset_id' must refer to an asset of one of the following types: png, jpeg, gif, webp, heic, heif, avif, tiff, jp2, jpx, jpm, jxr."
}
JSON

403 Forbidden

codestring

A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.

messagestring

A human-readable description of what went wrong.

Example error response

Not allowed to access the asset
{
"code": "permission_denied",
"message": "Not allowed to access this asset"
}
JSON

404 Not Found

codestring

A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.

messagestring

A human-readable description of what went wrong.

Example error response

The asset was not found
{
"code": "asset_not_found",
"message": "Asset not found"
}
JSON

429 Too Many Requests

codestring

A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.

messagestring

A human-readable description of what went wrong.

Example error response

User has reached their credit quota limit
{
"code": "credit_quota_exceeded",
"message": "User has exceeded their credit quota"
}
JSON

Try it out

This uses your live Canva data.

This is not a sandbox/playground. This form performs API requests against your account's actual live Canva data. Make sure that you understand what the request is doing, as well as the requirements for each parameter detailed above.

Step 1: Enter your access token

To get started, generate an access token or provide your own below